!     #########
    SUBROUTINE ALLOCATE_TEB_HYDRO(HM,KLU,KGROUND_LAYER)  
!   ##########################################################################
!
USE MODD_SURFEX_n, ONLY:TEB_HYDRO_MODEL_t
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
TYPE(TEB_HYDRO_MODEL_t), INTENT(INOUT) :: HM
INTEGER, INTENT(IN) :: KLU
INTEGER, INTENT(IN) :: KGROUND_LAYER
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!-------------------------------------------------------------------------------
!
! Mask and number of grid elements containing patches/tiles:
!
IF (LHOOK) CALL DR_HOOK('ALLOCATE_TEB_HYDRO',0,ZHOOK_HANDLE)
!
!-------------------------------------------------------------------------------
!
! Prognostic variables:
!
!
! - Soil heat and water:
!
ALLOCATE(HM%TH%CUR%XWG_ROAD                (KLU,KGROUND_LAYER      )) 
ALLOCATE(HM%TH%CUR%XWGI_ROAD               (KLU,KGROUND_LAYER      )) 
!ALLOCATE(HM%TH%CUR%XDRAIN_ROAD             (KLU))
!
ALLOCATE(HM%TH%CUR%XWG_BLD                 (KLU,KGROUND_LAYER      )) 
ALLOCATE(HM%TH%CUR%XWGI_BLD                (KLU,KGROUND_LAYER      ))
!ALLOCATE(HM%TH%CUR%XDRAIN_BLD              (KLU)) 
ALLOCATE(HM%TH%CUR%XNOC                    (KLU))
!
!
IF (LHOOK) CALL DR_HOOK('ALLOCATE_TEB_HYDRO',1,ZHOOK_HANDLE)
!
END SUBROUTINE ALLOCATE_TEB_HYDRO
