!     #############################################################
      SUBROUTINE DEALLOC_DIAG_SURF_ATM_n (DGU)
!     #############################################################
!
!!    AUTHOR
!!    ------
!!      V. Masson   *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004
!!      Modified    01/2006 : sea flux parameterization.
!!      B.Decharme  04/2013 : new diags
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!
!
USE MODD_DIAG_SURF_ATM_n, ONLY : DIAG_SURF_ATM_t
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*       0.1   Declarations of arguments
!              -------------------------
!
!*       0.2   Declarations of local variables
!              -------------------------------
!
!-------------------------------------------------------------------------------
!
!

!
TYPE(DIAG_SURF_ATM_t), INTENT(INOUT) :: DGU
!
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('DEALLOC_DIAG_SURF_ATM_N',0,ZHOOK_HANDLE)
DEALLOCATE(DGU%XRI_TILE     )
DEALLOCATE(DGU%XCD_TILE     )
DEALLOCATE(DGU%XCH_TILE     )
DEALLOCATE(DGU%XCE_TILE     )
DEALLOCATE(DGU%XQS_TILE     )
DEALLOCATE(DGU%XZ0_TILE     )
DEALLOCATE(DGU%XZ0H_TILE    )
DEALLOCATE(DGU%XRN_TILE     )
DEALLOCATE(DGU%XH_TILE      )
DEALLOCATE(DGU%XLE_TILE     )
DEALLOCATE(DGU%XLEI_TILE    )
DEALLOCATE(DGU%XGFLUX_TILE  )
DEALLOCATE(DGU%XEVAP_TILE   )
DEALLOCATE(DGU%XSUBL_TILE   )
DEALLOCATE(DGU%XT2M_TILE    )
DEALLOCATE(DGU%XTS_TILE     )
DEALLOCATE(DGU%XT2M_MIN_TILE)
DEALLOCATE(DGU%XT2M_MAX_TILE)
DEALLOCATE(DGU%XQ2M_TILE    )
DEALLOCATE(DGU%XHU2M_TILE   )
DEALLOCATE(DGU%XZON10M_TILE )
DEALLOCATE(DGU%XMER10M_TILE )
DEALLOCATE(DGU%XDIAG_TRAD   )
DEALLOCATE(DGU%XDIAG_EMIS   )
!
DEALLOCATE(DGU%XAVG_RI     )
DEALLOCATE(DGU%XAVG_CD     )
DEALLOCATE(DGU%XAVG_CH     )
DEALLOCATE(DGU%XAVG_CE     )
DEALLOCATE(DGU%XAVG_Z0     )
DEALLOCATE(DGU%XAVG_Z0H    )
DEALLOCATE(DGU%XAVG_RN     )
DEALLOCATE(DGU%XAVG_H      )
DEALLOCATE(DGU%XAVG_LE     )
DEALLOCATE(DGU%XAVG_LEI    )
DEALLOCATE(DGU%XAVG_GFLUX  )
DEALLOCATE(DGU%XAVG_EVAP   )
DEALLOCATE(DGU%XAVG_SUBL   )
DEALLOCATE(DGU%XAVG_T2M    )
DEALLOCATE(DGU%XAVG_TS     )
DEALLOCATE(DGU%XAVG_T2M_MIN)
DEALLOCATE(DGU%XAVG_T2M_MAX)
DEALLOCATE(DGU%XAVG_Q2M    )
DEALLOCATE(DGU%XAVG_HU2M   )
DEALLOCATE(DGU%XAVG_ZON10M )
DEALLOCATE(DGU%XAVG_MER10M )
DEALLOCATE(DGU%XAVG_SFCO2  )
DEALLOCATE(DGU%XAVG_T2M_MIN_ZS    )
DEALLOCATE(DGU%XAVG_Q2M_MIN_ZS    )
DEALLOCATE(DGU%XAVG_HU2M_MIN_ZS   )
DEALLOCATE(DGU%XPS                )
DEALLOCATE(DGU%XRHOA              )
!
DEALLOCATE(DGU%XRNC_TILE     )
DEALLOCATE(DGU%XHC_TILE      )
DEALLOCATE(DGU%XLEC_TILE     )
DEALLOCATE(DGU%XLEIC_TILE    )
DEALLOCATE(DGU%XGFLUXC_TILE  )
DEALLOCATE(DGU%XEVAPC_TILE   )
DEALLOCATE(DGU%XSUBLC_TILE   )
DEALLOCATE(DGU%XSWDC_TILE    )
DEALLOCATE(DGU%XSWUC_TILE    )
DEALLOCATE(DGU%XLWDC_TILE    )
DEALLOCATE(DGU%XLWUC_TILE    )
DEALLOCATE(DGU%XFMUC_TILE    )
DEALLOCATE(DGU%XFMVC_TILE    )
!
DEALLOCATE(DGU%XAVG_RNC     )
DEALLOCATE(DGU%XAVG_HC      )
DEALLOCATE(DGU%XAVG_LEC     )
DEALLOCATE(DGU%XAVG_LEIC    )
DEALLOCATE(DGU%XAVG_GFLUXC  )
DEALLOCATE(DGU%XAVG_EVAPC   )
DEALLOCATE(DGU%XAVG_SUBLC   )
DEALLOCATE(DGU%XAVG_SWDC    )
DEALLOCATE(DGU%XAVG_SWUC    )
DEALLOCATE(DGU%XAVG_LWDC    )
DEALLOCATE(DGU%XAVG_LWUC    )
DEALLOCATE(DGU%XAVG_FMUC    )
DEALLOCATE(DGU%XAVG_FMVC    )
!
DEALLOCATE(DGU%XHU2M_MIN_TILE    )
DEALLOCATE(DGU%XAVG_HU2M_MIN     )
DEALLOCATE(DGU%XHU2M_MAX_TILE    )
DEALLOCATE(DGU%XAVG_HU2M_MAX     )
DEALLOCATE(DGU%XWIND10M_TILE     )
DEALLOCATE(DGU%XAVG_WIND10M      )
DEALLOCATE(DGU%XWIND10M_MAX_TILE )
DEALLOCATE(DGU%XAVG_WIND10M_MAX  )
IF (LHOOK) CALL DR_HOOK('DEALLOC_DIAG_SURF_ATM_N',1,ZHOOK_HANDLE)
! 
!-------------------------------------------------------------------------------
!
END SUBROUTINE DEALLOC_DIAG_SURF_ATM_n
