!     #########
      SUBROUTINE READ_DEFAULT_SURF_ATM_n (CHU, DGU, USS, &
                                          HPROGRAM)
!     #######################################################
!
!!****  *READ_DEFAULT_SURF_ATM* - routine to read the default general configuration for surface
!!
!!    PURPOSE
!!    -------
!!
!!**  METHOD
!!    ------
!!
!!    EXTERNAL
!!    --------
!!
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!      V. Masson   *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2003 
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!
!
!
!
USE MODD_CH_SURF_n, ONLY : CH_SURF_t
USE MODD_DIAG_SURF_ATM_n, ONLY : DIAG_SURF_ATM_t
USE MODD_SURF_ATM_SSO_n, ONLY : SURF_ATM_SSO_t
!
USE MODE_MODELN_SURFEX_HANDLER
!
USE MODE_POS_SURF
!
USE MODI_GET_LUOUT
USE MODI_GET_DEFAULT_NAM_n
!
USE MODD_READ_NAMELIST, ONLY : LNAM_READ
!
USE MODN_SSO_n
USE MODN_SURF_ATM_n
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*       0.1   Declarations of arguments
!              -------------------------
!
!
TYPE(CH_SURF_t), INTENT(INOUT) :: CHU
TYPE(DIAG_SURF_ATM_t), INTENT(INOUT) :: DGU
TYPE(SURF_ATM_SSO_t), INTENT(INOUT) :: USS
!
 CHARACTER(LEN=6),  INTENT(IN)  :: HPROGRAM ! program calling GROUND
!
!*       0.2   Declarations of local variables
!              -------------------------------
!
!
LOGICAL           :: GFOUND         ! Return code when searching namelist
INTEGER           :: ILUOUT         ! output listing logical unit
INTEGER           :: ILUDES         ! .des file logical unit
INTEGER           :: IMI
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!-------------------------------------------------------------------------------
!
IF (LHOOK) CALL DR_HOOK('READ_DEFAULT_SURF_ATM_N',0,ZHOOK_HANDLE)
 CALL GET_LUOUT(HPROGRAM,ILUOUT)

 CALL GET_DEFAULT_NAM_n(HPROGRAM,'READ ',ILUDES)
!
IF (ILUDES==0 .AND. LHOOK) CALL DR_HOOK('READ_DEFAULT_SURF_ATM_N',1,ZHOOK_HANDLE)
IF (ILUDES==0) RETURN

IMI=GET_CURRENT_MODEL_INDEX_SURFEX()

IF (IMI.NE.-1 .AND. LNAM_READ) THEN
 CALL INIT_NAM_SSOn(USS)
 CALL INIT_NAM_CH_CONTROLn(CHU)
 CALL INIT_NAM_CH_SURFn(CHU)
 CALL INIT_NAM_DIAG_SURF_ATMn(DGU)
 CALL INIT_NAM_DIAG_SURFn(DGU)
 CALL INIT_NAM_WRITE_DIAG_SURFn(DGU)
ENDIF
! 
IF (LNAM_READ) THEN
 !
 !* reading of file with default value
 !  ----------------------------------
 !
 CALL POSNAM(ILUDES,'NAM_SSON',GFOUND,ILUOUT)
 IF (GFOUND) READ(UNIT=ILUDES,NML=NAM_SSOn)
 CALL POSNAM(ILUDES,'NAM_DIAG_SURFN',GFOUND,ILUOUT)
 IF (GFOUND) READ(UNIT=ILUDES,NML=NAM_DIAG_SURFn)
 CALL POSNAM(ILUDES,'NAM_WRITE_DIAG_SURFN',GFOUND,ILUOUT)
 IF (GFOUND) READ(UNIT=ILUDES,NML=NAM_WRITE_DIAG_SURFn)
 CALL POSNAM(ILUDES,'NAM_DIAG_SURF_ATMN',GFOUND,ILUOUT)
 IF (GFOUND) READ(UNIT=ILUDES,NML=NAM_DIAG_SURF_ATMn)
 CALL POSNAM(ILUDES,'NAM_CH_CONTROLN',GFOUND,ILUOUT)
 IF (GFOUND) READ(UNIT=ILUDES,NML=NAM_CH_CONTROLn)
 CALL POSNAM(ILUDES,'NAM_CH_SURFN',GFOUND,ILUOUT)
 IF (GFOUND) READ(UNIT=ILUDES,NML=NAM_CH_SURFn)
 !
ENDIF
!
IF (IMI.NE.-1) THEN
 CALL UPDATE_NAM_SSOn(USS)
 CALL UPDATE_NAM_CH_CONTROLn(CHU)
 CALL UPDATE_NAM_CH_SURFn(CHU)
 CALL UPDATE_NAM_DIAG_SURF_ATMn(DGU)
 CALL UPDATE_NAM_DIAG_SURFn(DGU)
 CALL UPDATE_NAM_WRITE_DIAG_SURFn(DGU)
ENDIF
IF (LHOOK) CALL DR_HOOK('READ_DEFAULT_SURF_ATM_N',1,ZHOOK_HANDLE)
!
!
!-------------------------------------------------------------------------------
!
END SUBROUTINE READ_DEFAULT_SURF_ATM_n
